@page "/tradefinder"

@using AntDesign
@using System.Text;
@using System.Net;
@using System.Linq;
@using FIOWebServer.Models
@using FIOWebServer.JsonPayloads
@using FIOWebServer.Components
@using Newtonsoft.Json
@using CurrieTechnologies.Razor.Clipboard

@inject ClipboardService Clipboard
@inject IMatToaster Toaster
@inject NavigationManager NavManager
@inject GlobalAppState GlobalAppState

@implements IDisposable

<div>
    <h1>Trade Finder</h1>
    <MatThemeProvider Theme="@blackTheme">
        @if (SearchLoading)
        {
            <Spin style="margin-left: 20px" size="large" />
        }
        else
        {
            <MatButton Style="margin-left: 20px; outline:0" Icon="search" OnClick="SearchClick">Search</MatButton>
        }
    </MatThemeProvider>
    <RadioGroup @bind-Value="SelectedSearchOption" ButtonStyle="@RadioButtonStyle.Solid">
        <Radio RadioButton Value="@("Origin")">Origin</Radio>
        <Radio RadioButton Value="@("Destination")">Destination</Radio>
        <Radio RadioButton Value="@("All")">All</Radio>
    </RadioGroup>
    <Popover Title="" Placement="@Placement.BottomLeft">
        <ContentTemplate>
            <p>
                <b>Origin</b> - Origin means that we want to buy our goods here and sell elsewhere<br />
                <b>Destination</b> - Destination means that we want to sell our goods here and buy elsewhere<br />
                <b>Both</b> - Both means that it does not matter where we buy or sell, we want the best possible route
            </p>
        </ContentTemplate>
        <ChildContent>
            <MatIcon style="transform:scale(0.75)" Icon="info" />
        </ChildContent>
    </Popover>
    <MatAutocompleteList Value="@ExchangeSearchString" Style="margin-left: 20px" Items="@availableExchanges"
        OnTextChanged="OnExchangeSearchStringChanged" Label="Exchange" />



    <div class="grid">
        <div class="main-table">
            <MatTable AllowSelection="true" Items="@TradeSearchModels" SelectionChanged=OnRowClick ShowPaging="true"
                @bind-PageSize="TradeSearchPageSize" Striped="true" UseSortHeaderRow="true" Style="font-size:10px">
                <MatTableHeader>
                    <MatSortHeaderRow SortChanged="@SortShipmentData">
                        <MatSortHeader Class=".tableHeader" Style="font-size:11px; font-weight:bold"
                            SortId="OriginExchangeCode" Attributes=@headerAtt>Origin</MatSortHeader>
                        <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="DestinationExchangeCode" Attributes=@headerAtt>
                            Destination
                        </MatSortHeader>
                        <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="CommodityTicker" Attributes=@headerAtt>MAT
                        </MatSortHeader>
                        <th colspan="2">Ask</th>
                        <th colspan="2">Bid</th>
                        <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="ProfitPerUnit" Attributes=@headerAtt>Profit per Unit
                        </MatSortHeader>
                        <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="Profit" Attributes=@headerAtt>Total Profit
                        </MatSortHeader>
                        <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="ProfitPer500" Attributes=@headerAtt>Total Profit per
                            500
                            T/m&sup3;</MatSortHeader>
                    </MatSortHeaderRow>
                    <MatSortHeaderRow SortChanged="@SortShipmentData">
                        <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="Ask">$</MatSortHeader>
                        <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="AskVolume">Vol.
                        </MatSortHeader>
                        <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="Bid">$</MatSortHeader>
                        <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="BidVolume">Vol.
                        </MatSortHeader>
                    </MatSortHeaderRow>
                </MatTableHeader>
                <MatTableRow>
                    <td style="width: 30px">@context.OriginExchangeCode</td>
                    <td style="width: 30px">@context.DestinationExchangeCode</td>
                    <td style="width: 30px">
                        <CommodityIcon MaterialTicker=@context.MaterialTicker
                            Category=@CommodityIcon.MatPayloadToCss(materials[context.MaterialTicker].CategoryName)>
                        </CommodityIcon>
                    </td>
                    <td style="width: 14.28%">@context.AskDisplay</td>
                    <td style="width: 14.28%">@context.AskVolume</td>
                    <td style="width: 14.28%">@context.BidDisplay</td>
                    <td style="width: 14.28%">@context.BidVolume</td>
                    <td style="width: 14.28%">@context.ProfitPerUnitDisplay</td>
                    <td style="width: 14.28%">@context.ProfitDisplay</td>
                    <td style="width: 14.28%">@((MarkupString)context.PayoutPricePer500UnitsDisplay)</td>
                </MatTableRow>
            </MatTable>
        </div>
        <div class="askbid-table">
            <p style="font-size: 14px;">Buy: @OriginExchangeTicker</p>
            <MatTable Items="@OriginOrderModelsLists" Striped="true" UseSortHeaderRow="true" Style="font-size:10px;"
                ShowPaging="false">
                <MatTableHeader>
                    <MatSortHeaderRow SortChanged="@SortOriginOrderData">
                        <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="CompanyName">Company
                        </MatSortHeader>
                        <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="ItemCount">Amount
                        </MatSortHeader>
                        <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="ItemCost">Price per unit
                        </MatSortHeader>
                    </MatSortHeaderRow>
                </MatTableHeader>
                <MatTableRow>
                    <td style="background: #ffa4a2;">@context.CompanyName</td>
                    <td style="background: #ffa4a2;">@context.ItemCount</td>
                    <td style="background: #ffa4a2;">@context.CostDisplay</td>
                </MatTableRow>
            </MatTable>
            <p style="font-size: 14px;">Sell: @DestinationExchangeTicker</p>
            <MatTable Items="@DestinationOrderModelsList" Striped="true" UseSortHeaderRow="true" Style="font-size:10px"
                ShowPaging="false">
                <MatTableHeader>
                    <MatSortHeaderRow SortChanged="@SortDestinationOrderData">
                        <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="CompanyName">Company
                        </MatSortHeader>
                        <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="ItemCount">Amount
                        </MatSortHeader>
                        <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="ItemCost">Price per unit
                        </MatSortHeader>
                    </MatSortHeaderRow>
                </MatTableHeader>
                <MatTableRow>
                    <td style="background: #b2fab4;">@context.CompanyName</td>
                    <td style="background: #b2fab4;">@context.ItemCount</td>
                    <td style="background: #b2fab4;">@context.CostDisplay</td>
                </MatTableRow>
            </MatTable>
        </div>
    </div>
</div>

@code{
    //TODO: Find a way to inline this in HTML
    Dictionary<string, object> headerAtt = new Dictionary<string, object>()
    {
        ["rowspan"] = 2
    };
}